#!/bin/tcsh

# this script replaces every occurence of REPLACE by BY in the file that is given as first argument
# if no program argument is provided, an error is given and the program stops 
# the powerfull command sed is used
# for security reasons the original file is saved in the /tmp/sed/ directory
 
set REPLACE="10;URL"  #"O:\/TW\/Win32App\/Xds"
set BY="3;URL"               #"C:\/Bin\/Xds"
   # precede any /, \, &, or newline with a \
   # use ' .. ' if text contains ", like '"bla"'

if ($#argv == 0 ) then
    echo "No arguments supplied... exiting"
    exit 1
else 
    set FILE=$argv[1]

#    if !(-x $FILE) then  # this is to prevent to call sed on executables (files marked with a x)

    set NBR = `grep $REPLACE $FILE | wc -l ` # count occurences

    if $NBR[1] > 0 then
      
      sed -e "s/$REPLACE/$BY/g w /tmp/sed2.txt" $FILE  > /tmp/sed.txt 

      set NBR = `wc -l /tmp/sed2.txt`

      if $NBR[1] > 0 then  # check again to be sure nothing went wrong

        mv $FILE /tmp/sed/$FILE
        mv /tmp/sed.txt $FILE
        echo "Replaced $NBR[1] lines in file $FILE :"
        more /tmp/sed2.txt
        rm /tmp/sed2.txt
      endif
    endif
    rm 0

#   else
#      echo 'sed is not invoked on executables'
#    endif
endif

